//================================================================
// Przykladowa petla glowna implementujaca symulacje zmiennokrokowa.
//
//
// Przyklad dolaczony artykulu "Jak nalezy pisac aktualizacje stanu gry"
// (C) 2010, Jacek "TeMPOraL" Zlydach
// http://temporal.pr0.pl/devblog/
//
// Kod moze byc uzywany w dowolnych celach. Ale mysle, ze osobie, ktora
// przeczytala wspomniany artykul powyzszy kod nie przyda sie do niczego
// innego niz do celow edukacyjnych (jak nie pisac aktualizacji).
//================================================================

// Funkcje zewnetrzne
float GetCurrentTime();	//zwraca aktualny czas systemowy w sekundach
void GrabInput();	//uzywana do zebrania danych z klawiatury, myszki, ect.
void UpdateGame(float dT);	//aktualizuje stan gry
void Render();	//odrysowuje ekran

// Glowna czesc przykladu

int main()
{
	float dt = 0.0f;	//czas od ostatniej aktualizacji
	float lastUpdateTime = GetCurrentTime();	//czas ostatniej aktualizacji
												//przykladowa funkcja GetCurrentTime() pobiera
												//nam od systemu aktualny czas w sekundach
	while(true)
	{
		dt = GetCurrentTime() - lastUpdateTime;	//obliczenie czasu od ostatniej klatki
		lastUpdate += dt;	//podmiana
		GrabInput();	//<-- zbieranie wejscia z klawiatury, myszki, sieci, itp.
		UpdateGame(dt);	//<-- aktualizacja fizyki i logiki gry
		RenderGame();	//<-- wyswietlenie aktualnego stanu na ekranie
	}
}
